#include "CGuetemasse.h"

CGuetemasse::CGuetemasse()
{
	// Haltestelle
	bewertung=0;
	bevoelkerungsUeberversorgung=-1;
	bevoelkerungsUnterversorgung=-1;
	flaechenUeberversorgung=-1;
	flaechenUnterversorgung=-1;
	flaechenVersorgunginProzent=-1;
	bevoelkerungsVersorgunginProzent=-1;
	quelleZielMatrix = new matrix(1,1);
	// Linienplan
	anzahlUmstiege=-1;
	anzahlVerbindungenmitUmstiegzwang=-1;
	gesamtfahrer=-1;
	direktfahrer=-1;
	mittlereReisezeit=-1;
	prozentsatzVerbindungendiekeineDirektfahrten=-1;
	Direktfahreranteil=-1;
	Streckenkilometer=-1;
	gesamteStreckenkilometer=-1;
	mittlereMindestreisezeit=-1;
	Reisezeitverlaengerung=-1;
	linienAnzahl = -1;
	// Fahrplan
	anzahlBusse = -1;
	fahrplanwirkungsgrad = -1;
	gesamtZeitaufwand = -1;
	netzbedingteWartezeiten = -1;
	wartezeitaufwand = -1;
	mindestwartezeitaufwand = -1;
	fahrgastfahrten = -1;
	// Global
	fahrplanintervall=-1;
	durchschnittlicheAnzahlBusse = -1;
	mittlereReisezeitGlobal = -1;
	anzahlPersonenProBus = -1;
	reisebewertung = new map2< int, int, CReisebewertung>;
	ReisezeitHS2HSAuto = new map2<int, int, double >;
}

CGuetemasse::~CGuetemasse()
{
	delete quelleZielMatrix;
	if (ReisezeitHS2HSAuto != 0)
	delete ReisezeitHS2HSAuto;
}

//---+++### Haltestelle ###+++---

double CGuetemasse::holenHaltestellenBewertung()
{
	//Debug(3,"holenHaltestellenBewertung");
	return bewertung;
}

void CGuetemasse::speichernAnzahlHaltestellen(int anzHaltestellen)
{
	//Debug(3,"speichernAnzahlHaltestellen");
	anzahlHaltestellen = anzHaltestellen;		
}


int CGuetemasse::holenAnzahlHaltestellen()
{
	//Debug(3,"holenAnzahlHaltestellen");
	return anzahlHaltestellen;	
}

void CGuetemasse::speichernBevoelkerungsUeberversorgung(double bevUeberversogung)
{ 
	//Debug(3,"speichernBevoelkerungsUeberversorgung");
	bevoelkerungsUeberversorgung=bevUeberversogung;
	bewertung = bevoelkerungsUeberversorgung+bevoelkerungsUnterversorgung+flaechenUeberversorgung+flaechenUnterversorgung;
}
double CGuetemasse::holenBevoelkerungsUeberversorgung()
{
	//Debug(3,"holenBevoelkerungsUeberversorgung");
	return bevoelkerungsUeberversorgung;
}

void CGuetemasse::speichernBevoelkerungsUnterversorgung(double bevUnterversorgung)
{  
	//Debug(3,"speichernBevoelkerungsUnterversorgung");
	bevoelkerungsUnterversorgung=bevUnterversorgung;
	bewertung = bevoelkerungsUeberversorgung+bevoelkerungsUnterversorgung+flaechenUeberversorgung+flaechenUnterversorgung;
}
double CGuetemasse::holenBevoelkerungsUnterversorgung()
{
	//Debug(3,"holenBevoelkerungsUnterversorgung");
	return bevoelkerungsUnterversorgung;
}

void CGuetemasse::speichernFlaechenUeberversorgung(double flUeberversogung)
{
	//Debug(3,"speichernFlaechenUeberversorgung");
	flaechenUeberversorgung=flUeberversogung;
	bewertung = bevoelkerungsUeberversorgung+bevoelkerungsUnterversorgung+flaechenUeberversorgung+flaechenUnterversorgung;
}
double CGuetemasse::holenFlaechenUeberversorgung()
{
	//Debug(3,"holenFlaechenUeberversorgung");
	return flaechenUeberversorgung;
}

void CGuetemasse::speichernFlaechenUnterversorgung(double flUnterversorgung)
{  
	//Debug(3,"speichernFlaechenUnterversorgung");
	flaechenUnterversorgung=flUnterversorgung;
	bewertung = bevoelkerungsUeberversorgung+bevoelkerungsUnterversorgung+flaechenUeberversorgung+flaechenUnterversorgung;
}
double CGuetemasse::holenFlaechenUnterversorgung()
{
	//Debug(3,"holenFlaechenUnterversorgung");
	return flaechenUnterversorgung;
}

void CGuetemasse::speichernFlaechenVersorgunginProzent(double flVersorgunginProzent)
{  
	//Debug(3,"speichernFlaechenVersorgunginProzent");
	flaechenVersorgunginProzent=flVersorgunginProzent;
}
double CGuetemasse::holenFlaechenVersorgunginProzent()
{
	//Debug(3,"holenFlaechenVersorgunginProzent");
	return flaechenVersorgunginProzent;
}

void CGuetemasse::speichernBevoelkerungsVersorgunginProzent(double bevVersorgunginProzent)
{   
	//Debug(3,"speichernBevoelkerungsVersorgunginProzent");
	bevoelkerungsVersorgunginProzent=bevVersorgunginProzent;
}
double CGuetemasse::holenBevoelkerungsVersorgunginProzent()
{
	//Debug(3,"holenBevoelkerungsVersorgunginProzent");
	return bevoelkerungsVersorgunginProzent;
}

void CGuetemasse::speichernFusswegProHaltestelle(double fWeg)
{
	//Debug(3,"speichernFusswegProHaltestelle");
	fusswegVonHS = fWeg;
}

double CGuetemasse::holenFusswegProHaltestelle(void)
{
	//Debug(3,"holenFusswegProHaltestelle");
	return fusswegVonHS;
}

//Methode, mit dem das Programm das Guetemass  ReisezeitHS2HSAuto wiederherstellt
void CGuetemasse::speichernReisezeitHS2HSAuto(map2<int, int, double > * reisezeit)
{	//Debug(3,"");
	ReisezeitHS2HSAuto = reisezeit;	}


void CGuetemasse::setzenReisezeitHS2HSAuto(map2<int, int, double > * reisezeit_Entfernung)
{	/**
 	 * Methode, mit dem das Haltestellen-Modul die Entfernung in Metern von jeder Haltestelle zu jeder anderen setzt.
 	 * Dazu wird eine Durchschnittsgeschwindigkeit eines Autos von 28 km/h angenommen, was 466,67 zurueckgelegten
 	 * Metern in einer Minute entspricht
	 */	
	//Debug(3,"setzenReisezeitHS2HSAuto");
	/*double entfernung;
	
	for (int i=0 ; i < anzahlHaltestellen ; i++)
	{
		for (int j=0 ; j < anzahlHaltestellen ; j++)
		{
			entfernung = (* reisezeit_Entfernung) (i,j);
			(* ReisezeitHS2HSAuto) (i,j) = (entfernung * (1 / 466.67));
		}
	}   */
	if (ReisezeitHS2HSAuto != 0)
	delete ReisezeitHS2HSAuto;
	
	ReisezeitHS2HSAuto = 0;
	
	speichernReisezeitHS2HSAuto(reisezeit_Entfernung);
}

map2<int, int, double > * CGuetemasse::holenReisezeitHS2HSAuto(void)
{	//Debug(3,"holenReisezeitHS2HSAuto");
	return  ReisezeitHS2HSAuto; 	}


void CGuetemasse::setzenQuelleZielMatrix(matrix * qzMatrix)
{	//Debug(3,"setzenQuelleZielMatrix:");
	if(qzMatrix != 0)
	{
		*quelleZielMatrix = *qzMatrix;		
		//Debug(3,quelleZielMatrix->dim1() << "x" << quelleZielMatrix->dim2());	
	}
}


//---+++### Linienplan ###+++---

void CGuetemasse::speichernAnzahlUmstiege(int anzUmstiege)
{              	//Debug(3,"speichernAnzahlUmstiege");
	anzahlUmstiege=anzUmstiege;	}

int CGuetemasse::holenAnzahlUmstiege()
{                //Debug(3,"holenAnzahlUmstiege");
	 return anzahlUmstiege;		}


void CGuetemasse::speichernAnzahlVerbindungenmitUmstiegzwang(double verbindungenmitUmstiegezwang)
{            	//Debug(3,"speichernAnzahlVerbindungenmitUmstiegzwang");
	anzahlVerbindungenmitUmstiegzwang=verbindungenmitUmstiegezwang; 	}

double CGuetemasse::holenAnzahlVerbindungenmitUmstiegzwang()
{         	//Debug(3,"holenAnzahlVerbindungenmitUmstiegzwang");
	return anzahlVerbindungenmitUmstiegzwang;				}
	

void CGuetemasse::speichernGesamtfahrer(int gesFahrer)
{        //Debug(3,"speichernGesamtfahrer");
         gesamtfahrer=gesFahrer;
}
int CGuetemasse::holenGesamtfahrer()
{                //Debug(3,"holenGesamtfahrer");
	return gesamtfahrer;
}

void CGuetemasse::speichernDirektfahrer(int dirFahrer)
{       //Debug(3,"speichernDirektfahrer");
        direktfahrer=dirFahrer;
}
int CGuetemasse::holenDirektfahrer()
{                //Debug(3,"holenDirketfahrer");
	return direktfahrer;
}

void CGuetemasse::speichernMittlereReisezeit(int mittlereReisezt)
{       //Debug(3,"speichernMittlereReisezeit");	
        mittlereReisezeit=mittlereReisezt;
}
int CGuetemasse::holenMittlereResezeit()
{               //Debug(3,"holenMittlereReisezeit");
	return mittlereReisezeit;
}

void CGuetemasse::speichernProzentsatzVerbindungendiekeineDirektfahrten(double prozentVerbdiekeineDirektfahrten)
{      	//Debug(3,"speichernProzentsatzVerbindungendiekeineDirektfahrten");
       	prozentsatzVerbindungendiekeineDirektfahrten=prozentVerbdiekeineDirektfahrten;
}
double CGuetemasse::holenProzentsatzVerbindungendiekeineDirektfahrten()
{                //Debug(3,"holenProzentsatzVerbindungendiekeineDirektfahrten");
	return prozentsatzVerbindungendiekeineDirektfahrten;
}

void CGuetemasse::speichernDirektfahreranteil(double direktFahrerAnt)
{     	//Debug(3,"speichernDirektfahreranteil");
       	Direktfahreranteil=direktFahrerAnt;
}
double CGuetemasse::holenDirektfahreranteil()
{                //Debug(3,"holenDirektfahreranteil");
	return Direktfahreranteil;
}

void CGuetemasse::speichernStreckenkilometer(int streckenkm)
{       //Debug(3,"speichernStreckenkilometer");
        //Das Linienplan - Modul liefert diesen Wert in Metern - die Umrechnung in KM geschieht hier!
        Streckenkilometer=streckenkm;
}
int CGuetemasse::holenStreckenkilometer()
{               	//Debug(3,"holenStreckenkilometer");
	return Streckenkilometer;
}

void CGuetemasse::speichernGesamteStreckenkilometer(int gesamteStreckenkm)
{       //Debug(3,"speichernGesamteStreckenkilometer");
        //Das Linienplan - Modul liefert diesen Wert in Metern - die Umrechnung in KM geschieht hier!
        gesamteStreckenkilometer=gesamteStreckenkm;
}
int CGuetemasse::holenGesamteStreckenkilometer()
{                //Debug(3,"holenGesamteStreckenkilometer");
	return gesamteStreckenkilometer;
}

void CGuetemasse::speichernMittlereMindestreisezeit(int mittleremindestreisezt)
{       //Debug(3,"speichernMittlereMindestreisezeit");
        mittlereMindestreisezeit=mittleremindestreisezt;
}
int CGuetemasse::holenMittlereMindestreisezeit()
{                //Debug(3,"holenMittlereMindestreisezeit");
	return mittlereMindestreisezeit;
}

void CGuetemasse::speichernReisezeitverlaengerung(double reiseztverlaengerung)
{        //Debug(3,"speichernReisezeitverlaengerung");
         Reisezeitverlaengerung=reiseztverlaengerung;
}
double CGuetemasse::holenReisezeitverlaengerung()
{                //Debug(3,"holenReisezeitverlaengerung");
	return Reisezeitverlaengerung;
}

void CGuetemasse::setzenLinienanzahl(int anzLinien)
{	//Debug(3,"setzenLinienanzahl");
	linienAnzahl = anzLinien;		}

int CGuetemasse::holenLinienanzahl(void)
{	//Debug(3,"holenLinienanzahl");
	return linienAnzahl;		}


void CGuetemasse::speichernMittlerenVerknuepfungsgrad(double grad)
{	//Debug(3,"speichernMittlerenVerknuepfungsgrad");
	mittlererVerknuepfungsgrad = grad;	}

double CGuetemasse::holenMittlerenVerknuepfungsgrad(void)
{ 	//Debug(3,"holenMittlerenVerknuepfungsgrad");
	return mittlererVerknuepfungsgrad;	}

//---+++### Fahrplan ###+++---

void CGuetemasse::speichernAnzahlBusse(double anzBusse)
{	//Debug(3,"speichernAnzahlBusse");
	anzahlBusse = anzBusse;		}

double CGuetemasse::holenAnzahlBusse(void)
{	//Debug(3,"holenAnzahlBusse");
	return anzahlBusse;		}


void CGuetemasse::speichernNetzbedingteWartezeitenGesamt(double netzWartezeit)
{	//Debug(3,"speichernNetzbedingteWartezeitenGesamt");
	netzbedingteWartezeiten = netzWartezeit;	}

double CGuetemasse::holenNetzbedingteWartezeitenGesamt(void)
{	//Debug(3,"holenNetzbedingteWartezeitenGesamt");
	return netzbedingteWartezeiten;		}
                                                                  	

void CGuetemasse::speichernWartezeiteAufwandGesamt(double wartezeit)
{	//Debug(3,"speichernWartezeiteAufwandGesamt");
	wartezeitaufwand = wartezeit;		}

double CGuetemasse::holenWartezeitenAufwandGesamt(void)
{	//Debug(3,"holenWartezeitenAufwandGesamt");
	return wartezeitaufwand;			}

	
void CGuetemasse::speichernMindestwartezeitaufwand(double mindwartezeit)
{	//Debug(3,"speichernMindestwartezeitaufwand");
	mindestwartezeitaufwand = mindwartezeit;	}

double CGuetemasse::holenMindestwartezeitaufwand(void)
{	//Debug(3,"holenMindestwartezeitaufwand");
	return mindestwartezeitaufwand;		}

	
void CGuetemasse::speichernGesamtzeitaufwand(double gesZeitaufwand)
{	//Debug(3,"speichernGesamtzeitaufwand");
	gesamtZeitaufwand = gesZeitaufwand;	}

double CGuetemasse::holenGesamtzeitaufwand(void)
{	//Debug(3,"holenGesamtzeitaufwand");
	return gesamtZeitaufwand;			}
	
void CGuetemasse::speichernFahrplanwirkungsgrad(double wirkungsgrad)
{ 	//Debug(3,"speichernFahrplanwirkungsgrad");
	fahrplanwirkungsgrad = wirkungsgrad;	}

double CGuetemasse::holenFahrplanwirkungsgrad(void)
{	//Debug(3,"holenFahrplanwirkungsgrad");
	return fahrplanwirkungsgrad;		}

void CGuetemasse::speichernFahrgastfahrten(int neuFahrgastfahrten){
  fahrgastfahrten = neuFahrgastfahrten;
}

int CGuetemasse::holenFahrgastfahrten(void){
  return fahrgastfahrten;
}

//---+++### Global ###+++---

//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	setzt das Fahrplanintervall
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
void CGuetemasse::setzenFahrplanintervall(double fpi)
{	fahrplanintervall = fpi;		}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	speichert die durchschn. Anzahl der Busse
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
void CGuetemasse::speichernDurchschnittlicheAnzahlBusse(double anzBusse)
{
	//Debug(3,"speichern durchschnittliche Anzahl Busse pro Linie");
	durchschnittlicheAnzahlBusse = anzBusse;
}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	gibt die durchschn. Anzahl der Busse zurueck
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
double CGuetemasse::holenDurchschnittlicheAnzahlBusse(void)
{
	//Debug(3,"holen durchschnittliche Anzahl Busse pro Linie");
	if (linienAnzahl != -1)
	{
		if (anzahlBusse != -1)
		durchschnittlicheAnzahlBusse = ( anzahlBusse / linienAnzahl );
		else
		durchschnittlicheAnzahlBusse = -1;
	}
	else
	durchschnittlicheAnzahlBusse = -1;
	
	
	//Debug(3,"durchschn. Anzahl Busse: "<<durchschnittlicheAnzahlBusse);
	return durchschnittlicheAnzahlBusse;
}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	setzt die mittlere Mind' eisezeit
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
void CGuetemasse::speichernMittlereReisezeit(double mittlereRZGlobal)
{               //Debug(3,"speichern mittlere Reisezeit");
	mittlereReisezeitGlobal = mittlereRZGlobal; 	}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	gibt die mittlere Mind.' eisezeit zurueck
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
double CGuetemasse::holenMittlereReisezeit(void)
{                /**
                  * Berechnet sich aus der Zeit fuer den Fussweg, der Fahrtreisezeit und der Wartezeit
	 */
	//Debug(3,"holen mittlere Reisezeit");
	double  wartezeitGesamt = 0;  	//in Minuten
	double  fahrzeitGesamt = 0; 		//in Minuten
	CReisebewertung * eineReisebewertung = new CReisebewertung;
	
	//Die Zeit fuer den Fussweg berechnen (4Km/h entspricht 66.67 m/min -> 0.01 min/m)
	//Die Meterangabe ist schon ein Mittelwert
	if (fusswegVonHS !=-1)
	{
	  if (anzahlHaltestellen != -1)
	  {
	    	double fusswegVonHS_Zeit = fusswegVonHS * 0.01;

	
		//Die Wartezeit steht in der reisebewertung. Dies gilt fuer jede Haltestelle
		//zu jeder anderen
		for (int i=0 ; i < anzahlHaltestellen ; i++)
		{
			for (int j=0 ; j < anzahlHaltestellen ; j++)
			{
				//Werte "von HS 1 zu HS 1" sind nicht eingetragen und muessen deswegen aus der Berechnung genommen werden
				if (i != j) {
				* eineReisebewertung =(* reisebewertung)(i,j);
				//Wartezeit herausholen
				wartezeitGesamt = eineReisebewertung->gebenWartezeit() + wartezeitGesamt;
				//fahrzeitGesamt = eineReisebewertung->gebenFahrzeit() + fahrzeitGesamt;
				}
			}
		}
		//ToDo: Normieren nach Anzahl Haltestellen ?????
		//Zeiten normieren, um einen Mittelwert zu erhalten
		wartezeitGesamt = (wartezeitGesamt / (anzahlHaltestellen * anzahlHaltestellen));
		//fahrzeitGesamt = (mittlereMindestreisezeit / anzahlHaltestellen);
	
		//Zeiten zusammenbringen
		mittlereReisezeitGlobal = fusswegVonHS_Zeit + wartezeitGesamt + mittlereMindestreisezeit;
	   }
	   else
	   mittlereReisezeitGlobal=-1;
	}
	else
	mittlereReisezeitGlobal=-1;
	
	Debug(3,"mittlereReisezeit: "<<mittlereReisezeitGlobal);
	return mittlereReisezeitGlobal; 		
}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	setzt die durchschn. Anzahl Personen
//		pro Bus
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
void CGuetemasse::speichernAnzahlPersonen(double anzPersonen)
{                //Debug(3,"speichern durchschnittliche Anzahl Personen pro Bus");
	anzahlPersonenProBus = anzPersonen;		}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	gibt die durchschn.Anzahl Personen
//		pro Bus zurueck
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
double CGuetemasse::holenAnzahlPersonen(void)
{	/**
	 * Berechnet die durchschnittliche Anzahl Personen pro Bus pro Takt.
	 * Dabei wird zuerst die QuelleZiel-Matrix ausgelesen, alle Werte kummuliert, um die
	 * Anzahl Personen pro Tag zu bekommen. Dieser Wert wird mal dem fahrplanintervall genommen
	 * und dann durch 24 Stunden geteilt, um auf die Anzahl Personen pro Takt zu kommen
	 * Diese wird dann durch die Anzahl der Busse pro Takt dividiert und man erhaelt die
	 * durchschnittliche Anzahl Personen pro Bus pro Takt.
	 */
	//Debug(3,"holen durchschnittliche Anzahl Personen pro Bus");
	double kummuliertePersonenanzahl = 0;
	
	if (quelleZielMatrix->dim1() > 1)
	{
		//Debug(3,quelleZielMatrix->dim1() << "x" << quelleZielMatrix->dim2());
	     	
		if( (fahrgastfahrten != -1) && (fahrplanintervall != -1))
		{
			//Anzahl Personen holen
			for (int i=0 ; i < quelleZielMatrix->dim1() ; i++)
			{	
				for (int j=0 ; j < quelleZielMatrix->dim2() ; j++)
				{
					kummuliertePersonenanzahl = (* quelleZielMatrix) (i,j) + kummuliertePersonenanzahl;
				}
			}
		kummuliertePersonenanzahl = kummuliertePersonenanzahl / 150;
    	                 anzahlPersonenProBus = ( ((kummuliertePersonenanzahl * fahrplanintervall)/24) / fahrgastfahrten);
    	                 }
		else
		anzahlPersonenProBus = -1;
		
	}
	else
	anzahlPersonenProBus = -1;
	
	Debug(3,"Anzahl Personen pro Bus: "<<anzahlPersonenProBus);
	return anzahlPersonenProBus;	
}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	setzt das Verhaeltnis mittlere Reisezeit
//		zu Direktfahrer
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
void CGuetemasse::speichernReisezeitZuDirektfahrer(double rzZudf)
{              	//Debug(3,"speichern mittlere Reisezeit im Verhaeltnis zu den Direktfahrern");
	reisezeitZuDirektfahrer = rzZudf;	}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	gibt das Verhaeltnis mittlere Reisezeit zu
//		Direktfahrer zurueck
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
double CGuetemasse::holenReisezeitZuDirektfahrer(void)
{
	//Debug(3,"holen mittlere Reisezeit im Verhaeltnis zu den Direktfahrern");	
	double direktfahrerzeit = -1;		//in Minuten
	
	//wenn die mittlere Reisezeit noch nicht gesetzt ist, kann
	//dieses Guetemass noch nicht berechnet werden.	
	if (mittlereReisezeitGlobal == -1)
	return -1;
	else
	{
	    if (anzahlHaltestellen != -1)
	    {
            		//Alle Direktfahrerzeiten holen und kummulieren
            		for (int i=0 ; i < anzahlHaltestellen ; i++)
		{
			for (int j=0 ; j < anzahlHaltestellen ; j++)
			{
				//Werte "von HS 1 zu HS 1" sind nicht eingetragen und muessen deswegen aus der Berechnung genommen werden
				if (i != j)
				direktfahrerzeit = (* ReisezeitHS2HSAuto) (i,j) + direktfahrerzeit;
			}
		}
		direktfahrerzeit = (direktfahrerzeit / (anzahlHaltestellen * anzahlHaltestellen)-anzahlHaltestellen);
		direktfahrerzeit = direktfahrerzeit * (1/466,67);
		 //Debug(4, "Direktfahrerzeit:"<<direktfahrerzeit);
	                  //Debug(4, "mittlere Mindestreisezeit:"<<mittlereReisezeitGlobal);
	                  //int dummy;
	                  //cin >> dummy;
		reisezeitZuDirektfahrer = (mittlereReisezeitGlobal /  direktfahrerzeit); // *100;
		
		Debug(3,"Reisezeit zu Direktfahrer: "<<reisezeitZuDirektfahrer);
            		return reisezeitZuDirektfahrer;
            	   }
            	}
}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	setzt das Verhaeltnis mittlere Mind.' reisezeit
//		zu Direktfahrer
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
void CGuetemasse::speichernMindestreisezeitZuDirektfahrer(double mrzZuDf)
{
	//Debug(3,"speichern Mindestreisezeit im Verhaeltnis zu den Direktfahrern");	
	mindestreisezeitZuDirektfahrer = mrzZuDf;
}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	gibt das Verhaeltnis Mind.Reisezeit
//		zu Direktfahrer zurueck
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
double CGuetemasse::holenMindestreisezeitZuDirektfahrer(void)
{
	//Debug(3,"holen Mindestreisezeit im Verhaeltnis zu den Direktfahrern");	
	double direktfahrerzeit = -1;		//in Minuten
	double wartezeitGesamt, fahrzeitGesamt;
	CReisebewertung * eineReisebewertung = new CReisebewertung;
	
	//Alle Direktfahrerzeiten holen und kummulieren
	if (anzahlHaltestellen != -1)
	{
	    if (mittlereMindestreisezeit != -1)
	      {
            		for (int i=0 ; i < anzahlHaltestellen ; i++)
		{
			for (int j=0 ; j < anzahlHaltestellen ; j++)
			{
				//Werte "von HS 1 zu HS 1" sind nicht eingetragen und muessen deswegen aus der Berechnung genommen werden
				if (i != j)
				direktfahrerzeit = (* ReisezeitHS2HSAuto) (i,j) + direktfahrerzeit;
			}
		}
		direktfahrerzeit = (direktfahrerzeit / (anzahlHaltestellen * anzahlHaltestellen)-anzahlHaltestellen);
	                  direktfahrerzeit = direktfahrerzeit * (1/466,67);
		//Die mittlereMindestreisezeit wird vom Linienplan berechnet und gesetzt
		//mittlere Mindestreisezeit (Reisezeit auf den kuerzesten Wegen mit dem Bus incl. der Wartenzeiten) berechnen
		/*for (int i=0 ; i < anzahlHaltestellen ; i++)
		{
			for (int j=0 ; j < anzahlHaltestellen ; j++)
			{
				//Werte "von HS 1 zu HS 1" sind nicht eingetragen und muessen deswegen aus der Berechnung genommen werden
				if (i != j)  {
				* eineReisebewertung =(* reisebewertung)(i,j);
				//Wartezeit herausholen
				wartezeitGesamt = eineReisebewertung->gebenWartezeit() + wartezeitGesamt;
				fahrzeitGesamt = eineReisebewertung->gebenFahrzeit() + fahrzeitGesamt;
				}
			}
		}
		wartezeitGesamt = (wartezeitGesamt / anzahlHaltestellen);
		fahrzeitGesamt = (fahrzeitGesamt / anzahlHaltestellen);
	
		mittlereMindestreisezeit = wartezeitGesamt + fahrzeitGesamt;*/
		//Debug(4, "Direktfahrerzeit:"<<direktfahrerzeit);
	                 //Debug(4, "mittlere Mindestreisezeit:"<<mittlereMindestreisezeit);
	                 //int dummy;
	                  //cin >> dummy;
		mindestreisezeitZuDirektfahrer = (mittlereMindestreisezeit  /  direktfahrerzeit); // *100;
	      }
	      else
	      mindestreisezeitZuDirektfahrer = -1;
	}
	else
	mindestreisezeitZuDirektfahrer = -1;
	
	Debug(3,"Mind. reisezeit zu Direktfahrer: "<<mindestreisezeitZuDirektfahrer);
            	return mindestreisezeitZuDirektfahrer;
}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	erzeugt ein HashArray fuer die Netz -
//		bedingten Wartezeiten
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
void CGuetemasse::erzeugenNetzbedingtenWartezeitenArray(void)
{
	//Debug(3,"erzeugen Netzbedingte Wartezeiten");	
	            if (NetzbedingtenWartezeitenArray != 0)
	            NetzbedingtenWartezeitenArray = new h_array< three_tuple<int, int, int>*, int >;
}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	setzt die Netzbedingten Wartezeiten
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
void CGuetemasse::setzenNetzbedingteWartezeiten( h_array< three_tuple<int, int, int >*, int> * NWArray)
{
	//Debug(3,"setzen Netzbedingte Wartezeiten");	
	NetzbedingtenWartezeitenArray = NWArray;
}



//------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	gibt die Netzbedingten Wartezeiten zurueck
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
h_array< three_tuple<int, int , int>*, int> * CGuetemasse::holenNetzbedingteWartezeiten(void)
{
	//Debug(3,"holen Netzbedingte  Wartezeiten");	
	return  NetzbedingtenWartezeitenArray;
}



 //------------------------------------------------------------------------------
// Dateiname:	CGuetemasse.cpp
// Beschreibung:	gibt die Reisebewertungen zurueck
// Autor(en):	Joerg Draeger	
// Version:	0.1
// Gendert von:	
// Gendert am:		
// Zustand:	Erst-Version
//------------------------------------------------------------------------------
map2 <int, int, CReisebewertung > * CGuetemasse::holenReisebewertung(void)
{
	//Debug(3,"holen Reisebewertung");
	return reisebewertung;
}

void CGuetemasse::speichernReisebewertung(map2 <int, int, CReisebewertung > * neueReisebewertung){
    reisebewertung = neueReisebewertung;
}
