// Allgemeine Konfigurationsdatei...
//
// Autor: Tim Schuermann
//

#ifndef DEFINE_H
#define DEFINE_H

// Legt den Debug-Level fest
#define DEBUG_LEVEL 9

// Wird folgendes auskommentiert, wird GRASS beim Starten initialisiert.
// Anmerkung: falls es zu Problemen mit eigenen Testprogrammen gibt, muss
// folgende Zeile auskommentiert werden.
#define MIT_GRASS

// Ist folgendes nicht auskommentiert (also an), liefert der Linienplan
// seine fest verdrahteten Dummy-Daten
//#define LINIENPLANDUMMYDATEN

// einige sinnvolle Konstanten
const double MAX_DOUBLE = 10000000.0;
const double MIN_DOUBLE = -10000000.0;
const double PI = 3.4142;

#endif // DEFINE_H
