#include "CTransportkettengraph.h"
#include <LEDA/graph.h>
#include "CFPlanGraphKante.h"
#include "CSchnittstellenTest.h"
#include "CFPlanGraphKnoten.h"
#include <string.h>


int main(int argc, char* argv[]) {
  CSchnittstellenTest* Schnitt = new CSchnittstellenTest();

  Schnitt->fahrplanerstellungWegenetzplan();

  if (argc > 1) {
    if (strcmp(argv[1],"-h") == 0) {
        Schnitt->fahrplanerstellungHeuristischeLoesung (0);
      if (argc > 2) {
        if (strcmp(argv[2],"-s") == 0) {
          Schnitt->fahrplanerstellungSukzessiveLoesungsverbesserung (0);
        }
      }
    }
    if (strcmp(argv[1],"-e") == 0) {
      if (argc > 2) {
        Schnitt->fahrplanerstellungEntscheidungsbaumverfahren (0,atoi(argv[2]));
      } else {
	Schnitt->fahrplanerstellungEntscheidungsbaumverfahren (0,0);
      }
    }
  } else {
    Schnitt->fahrplanerstellungHeuristischeLoesung (0);
  } 
  
  Schnitt->fahrplanerstellungAusgabeFahrplan();

  // Schnitt->fahrplanerstellungBerechnenFahrzeugAnzahl ();

  Schnitt->fahrplanerstellungBerechnenWartezeiten ();
  
  Debug (5, "CFahrplanTest::main->"  << "Ende der ueberragenden Fahrplanberechnung !!!");

  delete Schnitt; 
  return 0;
}





