//------------------------------------------------------------------------------
// Projektname:		
// Dateiname:		$RCSfile: CHeuristischesLoesungsverfahren.cpp,v $
// Beschreibung:	
// Autor(en):		Michael Wintergerst
// Version:			$Revision: 1.9 $
// Gendert von:	$Author: schuerma $
// Gendert am:		$Date: 2001/07/13 16:23:18 $
// Zustand:			$State: Exp $
//------------------------------------------------------------------------------

#include "CHeuristischesLoesungsverfahren.h"

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CHeuristischesLoesungsverfahren::CHeuristischesLoesungsverfahren (
     int zusammenhangskomponentenID, CTransportkettengraph* transportkettengraph) :
  CLoesungsgenerator (zusammenhangskomponentenID, transportkettengraph) {

}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CHeuristischesLoesungsverfahren::~CHeuristischesLoesungsverfahren () {

}

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CHeuristischesLoesungsverfahren::starten(){
//  std::cout << "\nBerechnen Maximalgeruest fuer Zusammenhangskomponente " <<
//    this->zusammenhangskomponentenID << endl;
  this->Transportkettengraph->berechnenMaximalgeruest (this->zusammenhangskomponentenID);
  
//  std::cout << "\nBerechnen Simplextableau fuer Zusammenhangskomponente " <<
//  zusammenhangskomponentenID << endl;
  this->Transportkettengraph->berechnenSimplexTableau (this->zusammenhangskomponentenID);
//  std::cout << "\nBerechnen Wartezeiten" << endl;
//  std::cout.flush();
  this->Transportkettengraph->berechnenWartezeitResultate ();
} // ende berechnenHeuristischeFahrplanerstellung

void CHeuristischesLoesungsverfahren::stoppen(){
}
