#include "CVerbindung.h"

CVerbindung::CVerbindung(){
  Start = NULL;
  Ziel = NULL;
  Verbindung = NULL;
  Laenge = 0.0;
}

CVerbindung::CVerbindung(node * Start, node * Ziel){
  setzenStart(Start);
  setzenZiel(Ziel);
  Verbindung = NULL;
  Laenge = 0.0;
}

CVerbindung::~CVerbindung() {
  delete Start;
  delete Ziel;
  for (int i=0; i<Verbindung->size(); i++) {
    delete Verbindung->contents(Verbindung->get_item(i));
  }
  Verbindung->clear();
  delete Verbindung;
}

void CVerbindung::setzenStart(node * Start) {
  this->Start = Start;
}

node * CVerbindung::holenStart(void) {
  return Start;
}

void CVerbindung::setzenZiel(node * Ziel) {
  this->Ziel = Ziel;
}

node * CVerbindung::holenZiel(void) {
  return Ziel;
}

void CVerbindung::setzenVerbindung(list<CPunkt *> * Verbindung) {
  this->Verbindung = Verbindung;
}

// Liefert den Realweg zurueck
list<CPunkt * > * CVerbindung::holenVerbindung(void) {
  return Verbindung;
}

void CVerbindung::setzenLaenge(double Laenge) {
  this->Laenge = Laenge;
}

// Laenge des Realweges
double CVerbindung::holenLaenge(void) {
  return Laenge;
}
