#include "Haltestelle.h"
#include "CFortschritt.h"

//______________________________________________________________________________

int CTestStrassennetz::Haltestelle_Stochastisch(CPunkt * DerPunkt)
{
  double a, b;
  a = drand48();
  b = drand48();
  DerPunkt->setzen(a,b);
  return 0;
}


//______________________________________________________________________________

void CTestStrassennetz::starten(void) {
//  double myx=1, myy=2;
  CPunkt myp;

  /* Zufaelligkeit erzwingen */
  srand48((long) time(0));

  cout << "Haltestellen-Berechnungsmodul " << $VERSION << " meldet sich zur Stelle.\n";	
  Debug(1, "[Haltestelle: Main] Berechne nun Haltestellen...");
  /*  for (int i=0;i<100;i++)
      {
      cout << i+1 << " ";
      Haltestelle_Stochastisch(&myp);
      myp.holen(&myx, &myy);
      cout << "X: " << myx << " Y: " << myy << "\n";
      };
  */

  
  //berechnenKreuzungen  testen:
  
  //cout << "Testen der Kreuzungsberechnung\n";

  /**4 Punkte, die die Geraden definieren: 
   *    1. Strasse (x=2,y=15) (x=5,y=33)
   *    2. Strasse (x=1.5,y=0) (x=7.35,y=18.72)
   * Schnittpunkt: x=-2.79, y=-13.74
    */

 CPunkt * APkt_Str_1, * EPkt_Str_1;
  CPunkt * APkt_Str_2, * EPkt_Str_2;
  list<CPunkt*> * Strasse_1, * Strasse_2;
  
  APkt_Str_1 = new CPunkt();
  EPkt_Str_1 = new CPunkt();
  APkt_Str_2 = new CPunkt();
  EPkt_Str_2 = new CPunkt();
  
  Strasse_1 = new list<CPunkt*>;
  Strasse_2 = new list<CPunkt*>;
  
  APkt_Str_1->setzen(2,6);
  EPkt_Str_1->setzen(4,4);
  APkt_Str_2->setzen(5,9);
  EPkt_Str_2->setzen(5,8);
  
  Strasse_1->append(APkt_Str_1);
  Strasse_1->append(EPkt_Str_1);
  Strasse_2->append(APkt_Str_2);
  Strasse_2->append(EPkt_Str_2);
  
  APkt_Str_1 = new CPunkt();
  EPkt_Str_1 = new CPunkt();
  APkt_Str_2 = new CPunkt();
  EPkt_Str_2 = new CPunkt();
  
  APkt_Str_1->setzen(6,6);
  EPkt_Str_1->setzen(8,6);
  APkt_Str_2->setzen(4,7);
  EPkt_Str_2->setzen(6,4);
  
  Strasse_1->append(APkt_Str_1);
  Strasse_1->append(EPkt_Str_1);
  Strasse_2->append(APkt_Str_2);
  Strasse_2->append(EPkt_Str_2);
  
  APkt_Str_1 = new CPunkt();
  EPkt_Str_1 = new CPunkt();
  APkt_Str_2 = new CPunkt();
  EPkt_Str_2 = new CPunkt();
  
  APkt_Str_1->setzen(9,7);
  EPkt_Str_1->setzen(9,8);
  APkt_Str_2->setzen(10,7);
  EPkt_Str_2->setzen(9,9);
  
  Strasse_1->append(APkt_Str_1);
  Strasse_1->append(EPkt_Str_1);
  Strasse_2->append(APkt_Str_2);
  Strasse_2->append(EPkt_Str_2);
  
  APkt_Str_1 = new CPunkt();
  EPkt_Str_1 = new CPunkt();
  APkt_Str_2 = new CPunkt();
  EPkt_Str_2 = new CPunkt();

  APkt_Str_1->setzen(8,9);
  EPkt_Str_1->setzen(8,11);
  APkt_Str_2->setzen(9,10);
  EPkt_Str_2->setzen(7,10);
  
  Strasse_1->append(APkt_Str_1);
  Strasse_1->append(EPkt_Str_1);
  Strasse_2->append(APkt_Str_2);
  Strasse_2->append(EPkt_Str_2);

//  char ausgabe[100];

  //    forall(APkt_Str_1,*Strasse_1)
  //    {  
  //       APkt_Str_1->holen(&myx,&myy);
  //       sprintf(ausgabe,"Punkt %f %f", myx, myy);
  //       Debug(6,ausgabe);
  //    }
  
  //    forall(APkt_Str_1,*Strasse_2)
  //    {  
  //       APkt_Str_1->holen(&myx,&myy);
  //       sprintf(ausgabe,"Punkt %f %f", myx, myy);
  //       Debug(6,ausgabe);
  //    }
  

  //cout << "Laenge Strasse1: " << ermittelnLaenge(Strasse_1) << "\n";
  //cout << "Laenge Strasse2: " << ermittelnLaenge(Strasse_2) << "\n";

  //berechnenKreuzungen(Strasse_1,Strasse_2);
  faellenLot(new CPunkt(0,4), new CPunkt(1,1),new CPunkt(1,10));
  faellenLot(new CPunkt(4,0), new CPunkt(1,1),new CPunkt(10,1));
  faellenLot(new CPunkt(5,0), new CPunkt(1,1),new CPunkt(10,10));


  //Anfang: Zu Testzwecken  der Methode ermittelnInzidenteKnoten()

  /*     cout << "Testen der Methode ermittelnInzidenteKnoten()\n...";

       Strassennetz2 = new GRAPH<CPunkt * ,list<CPunkt*> >;
       CPunkt * EinPunkt;
       node * Knoten = new node();
       node * EndeKn = new node();
       list<node* > * Liste = new list<node* >;
       list_item * it = new list_item();
       list<CPunkt *> * EineListe = new list<CPunkt* >;
       edge * Kante = new edge();
       node * KreuzungsKnoten_1;
       node * KreuzungsKnoten_2;

       cout << "...Alle Variablen initialisiert...\n";


       EinPunkt = new CPunkt();
       EinPunkt->setzen(1,1);
       *Knoten = Strassennetz2->new_node(EinPunkt);
       Liste->append(Knoten);       	
       Knoten = new node();

       EinPunkt = new CPunkt();
       EinPunkt->setzen(2,2);
       *Knoten = Strassennetz2->new_node(EinPunkt);
       Liste->append(Knoten);
       Knoten = new node();

       EinPunkt = new CPunkt();
       EinPunkt->setzen(3,3);
       *Knoten = Strassennetz2->new_node(EinPunkt);
       Liste->append(Knoten);
       Knoten = new node();

       EinPunkt = new CPunkt();
       EinPunkt->setzen(4,4);
       *Knoten = Strassennetz2->new_node(EinPunkt);
       Liste->append(Knoten);
       Knoten = new node();

      EinPunkt = new CPunkt();
       EinPunkt->setzen(5,5);
       *Knoten = Strassennetz2->new_node(EinPunkt);
       Liste->append(Knoten);
       Knoten = new node();

       EinPunkt = new CPunkt();
       EinPunkt->setzen(6,6);
       *Knoten = Strassennetz2->new_node(EinPunkt);
       Liste->append(Knoten);
       Knoten = new node();

       EinPunkt = new CPunkt();
       EinPunkt->setzen(7,7);
       *Knoten = Strassennetz2->new_node(EinPunkt);
       Liste->append(Knoten);
       Knoten = new node();

       cout << "Knoten erzeugt und in Liste eingefuegt\n";

       int i = 0;
       forall (Knoten, *Liste)
       {
       	EinPunkt = Strassennetz2->inf(*Knoten);
       	cout << "Listeneintrag " << i <<" mit Inhalt  "<< *EinPunkt <<"\n";
       	i++;
       }

       cout << "...alle Knoten mit Inhalt CPunkten erzeugt...\n";

       *it = Liste->get_item(0);
       Knoten = Liste->contents(*it);
       *it = Liste->get_item(1);
       EndeKn = Liste->contents(*it);
       Strassennetz2->new_edge(*Knoten,*EndeKn, *EineListe);

       *it = Liste->get_item(0);
       Knoten = Liste->contents(*it);
       *it = Liste->get_item(2);
       EndeKn = Liste->contents(*it);
       Strassennetz2->new_edge(*Knoten,*EndeKn, *EineListe);

       *it = Liste->get_item(1);
       Knoten = Liste->contents(*it);
       *it = Liste->get_item(2);
       EndeKn = Liste->contents(*it);
       Strassennetz2->new_edge(*Knoten,*EndeKn, *EineListe);

       *it = Liste->get_item(2);
       Knoten = Liste->contents(*it);
       *it = Liste->get_item(4);
       EndeKn = Liste->contents(*it);
       Strassennetz2->new_edge(*Knoten,*EndeKn, *EineListe);

       *it = Liste->get_item(2);
       Knoten = Liste->contents(*it);
       *it = Liste->get_item(3);
       EndeKn = Liste->contents(*it);
       Strassennetz2->new_edge(*Knoten,*EndeKn, *EineListe);

        *it = Liste->get_item(3);
       Knoten = Liste->contents(*it);
       *it = Liste->get_item(5);
       EndeKn = Liste->contents(*it);
       Strassennetz2->new_edge(*Knoten,*EndeKn, *EineListe);

        *it = Liste->get_item(5);
       Knoten = Liste->contents(*it);
       *it = Liste->get_item(6);
       EndeKn = Liste->contents(*it);
       *Kante = Strassennetz2->new_edge(*Knoten,*EndeKn, *EineListe);

       cout << "...Der StrassennetzGraph (2) ist aufgebaut...\n...Nun Methodenaufruf...\n";

       //Methoden - Aufruf:
      ermittelnInzidenteKnoten(Kante, KreuzungsKnoten_1, KreuzungsKnoten_2);

       cout << "...zum Schluss noch die Kreuzungsinformationen ausgeben:\n";

       //Kreuzungsinformationen auslesen
       EinPunkt = new CPunkt();
       EinPunkt = Strassennetz2->inf(*KreuzungsKnoten_1);
       cout << "1. Kreuzung ist bei dem Punkt " << *EinPunkt << "\n";
       EinPunkt = new CPunkt();
       EinPunkt = Strassennetz2->inf(*KreuzungsKnoten_2);
       cout << "2. Kreuzung ist bei dem Punkt " << *EinPunkt << "\n";	*/

}

//______________________________________________________________________________

int main ( int argc, char ** argv) {
  CTestStrassennetz TestNetz;
  TestNetz.starten();
  CFortschritt Fortschritt;
  for (unsigned int i=0; i<1000000; i++) {
    if (i%1000==0)
    Fortschritt.anzeigenFortschritt(i,1000000);
  }
  for (unsigned int i=0; i<1000000; i++) {
    if (i%1000==0)
    Fortschritt.anzeigenAktivitaet();
  }
  return 0;
}
//______________________________________________________________________________
