#include "CFPlanGraphKante.h"

//------------------------------------------------------------------------------
// Funktionsname:	CFPlanGraphKante
// Beschreibung:	Default Konstruktuor
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CFPlanGraphKante::CFPlanGraphKante(){
  this->verkehrsstrom = 0;
  this->fahrtzeit = 0;
  this->linienID = 0;
}

//------------------------------------------------------------------------------
// Funktionsname:	CFPlanGraphKante
// Beschreibung:	Kopier Konstruktor
// Parameter:		Das zu kopierende Objekt
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CFPlanGraphKante::CFPlanGraphKante(const CFPlanGraphKante& originalBeschriftung){
  this->verkehrsstrom = originalBeschriftung.verkehrsstrom;
  this->fahrtzeit = originalBeschriftung.fahrtzeit;
  this->linienID = originalBeschriftung.linienID;
}
    
//------------------------------------------------------------------------------
// Funktionsname:	operator=
// Beschreibung:	= Operator
// Parameter:		Das zu kopierende Objekt
// Rueckgabe:		Zeiger auf das kopierte Objekte
// Besonderheiten:	
//------------------------------------------------------------------------------
CFPlanGraphKante CFPlanGraphKante::operator= (const CFPlanGraphKante& originalBeschriftung){
  if (this!=&originalBeschriftung) {
    this->verkehrsstrom = originalBeschriftung.verkehrsstrom;
    this->fahrtzeit = originalBeschriftung.fahrtzeit;
    this->linienID = originalBeschriftung.linienID;
  }
  return *this;
}
    
//------------------------------------------------------------------------------
// Funktionsname:	operator>>
// Beschreibung:	>> Operator
// Parameter:	        	
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
istream& operator>> (istream& is, CFPlanGraphKante& beschriftung){
  
  is >> beschriftung.linienID >> beschriftung.fahrtzeit >>  beschriftung.verkehrsstrom; 
  is.clear();
  return is;
}

//------------------------------------------------------------------------------
// Funktionsname:	operator<<
// Beschreibung:	<< Operator
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
ostream& operator<< (ostream& os, const CFPlanGraphKante& beschriftung){
  os << "(" << beschriftung.linienID << "," << beschriftung.fahrtzeit << "," << beschriftung.verkehrsstrom << ")";
  
  return os;

}

int CFPlanGraphKante::holenVerkehrsstrom(){
	return this->verkehrsstrom;
}

int CFPlanGraphKante::holenFahrtzeit(){
	return this->fahrtzeit;
}

int CFPlanGraphKante::holenLinienID(){
	return this->linienID;
}

void CFPlanGraphKante::setzenVerkehrsstrom(int strom){
  this->verkehrsstrom = strom;
}

void CFPlanGraphKante::setzenFahrtzeit(int fahrtzeit){
  this->fahrtzeit = fahrtzeit;
}

void CFPlanGraphKante::setzenLinienID(int linienID){
  this->linienID = linienID;
}
