//------------------------------------------------------------------------------
// Projektname:		Modul - Fahrplan
// Dateiname:	        CVisualFahrplan.cpp
// Beschreibung:	dient der Visualisierung eines Graphen
// Autor(en):		Michael Wintergerst
// Version:		0.1
// Gendert von:	Michael Wintergerst
// Gendert am:		22.01.2001; neuer Konstruktor
// Zustand:		Erste Version
//------------------------------------------------------------------------------

#include "CVisualFahrplan.h"

//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
CVisualFahrplan::CVisualFahrplan (graph *graphToDraw) {
  this->graphToDraw = graphToDraw;
}
       
//------------------------------------------------------------------------------
// Funktionsname:	
// Beschreibung:	
// Parameter:		
// Rueckgabe:		
// Besonderheiten:	
//------------------------------------------------------------------------------
void CVisualFahrplan::Zeichnen (int breite, int hoehe) {
  GraphWin gw(*graphToDraw, breite, hoehe);
  gw.set_node_radius (5);
  gw.set_node_label_font (roman_font, 8);
  gw.set_edge_label_font (roman_font, 8);
  gw.set_node_label_pos (southeast_pos);
  gw.set_node_label_type (data_label);
  gw.set_edge_label_pos (central_pos);
  gw.set_edge_label_type (data_label);

  gw.display (0, 0);
  gw.place_into_win ();
  gw_center_graph (gw);
  gw_zoom_down(gw);
  gw_circle_embed(gw);
  gw_spring_embed(gw);  
  gw.edit ();
}
