class CPlanquadrat {
private:
	unsigned int X;
	unsigned int Y;
	list<CStrasse*>* Strassen;
public:
	/**
	 * Bestimmt die ID eines Planquadrates.
	 */
	void setzen(unsigned int X, unsigned int Y);
	
	/**
	 * Holt die X-ID eines Planquadrates.
	 */
	unsigned int holenX(void);
	
	/**
	 * Holt die Y-ID eines Planquadrates.
	 */
	unsigned int holenY(void);
	
	/**
	 * Liefert alle Strassen zurueck, welche das Planquadrat beruehren.
	 */
	list<CStrasse*> holenStrassen(void);

	/**
	 * Fuegt eine Strasse diesem Planquadrat hinzu.
	 */	
	void hinzufuegenStrasse(CStrasse * Strasse);
	
	/**
	 * Loescht alle Strassen aus dem Planquadrat.
	 */
	void loeschenStrassen(void);
	
	/**
	 * Entfernt die uebergebene Strasse aus dem Planquadrat.
	 */
	void loeschenStrasse(CStrasse * Strasse);
};