
#include "CLinienplanTestReza.h"

void holenDaten(matrix*& verkehrsbedarfsmatrix, list<CLinie*>*& vorgegebeneLinien,
		UGRAPH<CNetzplanKnoten*,CNetzplanKante*>*& netzplangraph)
{
  node ka[10];
  CNetzplanKante *kante;
	
  Debug (2,"Erzeuge Testdaten fuer Linienplan");
	
  //Verkehrsbedarfmatrix
  Debug (3,"Lege Verkehrsbedarfmatrix an");
  //verkehrsbedarfsmatrix = new matrix (9,9);
  /*ifstream vb("/home/pg369/share/verkehrsbedarfmatrix.txt", ios::in|ios::nocreate);
    vb >> *verkehrsbedarfsmatrix;
    vb.close(); */
  double vb[100];
  int i,j;
  srand(2);
  for (i=0;i<10;i++) {
    for (j=0;j<10;j++) {
      if ((i == 0) || (j == 0)) vb[i*10+j] = 0;
      else
	vb[i*10+j] = ((int)(rand()*1.2) >> 10);
    }
  }

  for (i=0;i<10;i++){
    for (j=0;j<10;j++) {
      if (i == j) vb[i*10+j] = 0;
      if (i > j) {
	vb[i*10+j] += vb[j*10+i];
	vb[j*10+i] = vb[i*10+j];
      }
    }
  }

  verkehrsbedarfsmatrix = new matrix(10,10,vb);

  Debug (3,"Lege Liste vorgegebener Linien an");
  vorgegebeneLinien = new list<CLinie*>;
	
  Debug (3,"Lege Wegenetzgraph an");
  netzplangraph = new UGRAPH<CNetzplanKnoten*,CNetzplanKante*>;
  for (int i = 0 ; i<9 ; i++){
    CNetzplanKnoten* beschriftung = new CNetzplanKnoten(i+1,10); //Alle Knoten kriegen Pri 10
    switch (i) { //Ausser ein paar, die sind anders
    case 0:
    case 5:
      beschriftung->setzenPrioritaet(8);
      break;
    case 3:
    case 4:
      beschriftung->setzenPrioritaet(5);
      break;
    case 7:
      beschriftung->setzenPrioritaet(7);
      break;
    }
    ka[i]=netzplangraph->new_node(beschriftung);
  }
  Debug (3,"verknuepfe knoten");
  kante=new CNetzplanKante(150,305,1,1);
  netzplangraph->new_edge(ka[0],ka[1],kante);
  kante=new CNetzplanKante(350,480,2,2);
  netzplangraph->new_edge(ka[1],ka[2],kante);
  kante=new CNetzplanKante(50,312,1,3);
  netzplangraph->new_edge(ka[2],ka[3],kante);
  kante=new CNetzplanKante(83,361,0,4);
  netzplangraph->new_edge(ka[2],ka[4],kante);
  kante=new CNetzplanKante(487,303,0,5);
  netzplangraph->new_edge(ka[3],ka[8],kante);
  kante=new CNetzplanKante(580,311,0,6);
  netzplangraph->new_edge(ka[3],ka[7],kante);
  kante=new CNetzplanKante(110,276,2,7);
  netzplangraph->new_edge(ka[3],ka[4],kante);
  kante=new CNetzplanKante(323,359,1,8);
  netzplangraph->new_edge(ka[4],ka[5],kante);
  kante=new CNetzplanKante(599,359,1,9);
  netzplangraph->new_edge(ka[4],ka[6],kante);
	
  edge_map<int>* kantenListe;
  edge hilfsKante;
  node netzplanhilfsknoten;
  forall_nodes(netzplanhilfsknoten, *netzplangraph){
    kantenListe = (netzplangraph->inf(ka[0]))->holenKantenListe();
    kantenListe->init(*netzplangraph,0);
  }

  kantenListe = (netzplangraph->inf(ka[0]))->holenKantenListe();
  forall_adj_edges (hilfsKante,ka[0]) {
    switch( (netzplangraph->inf (hilfsKante))->holenID() ) {
    case  1 : (*kantenListe)[hilfsKante] = 305;
      break;
    }
  }
	
  kantenListe = (netzplangraph->inf(ka[1]))->holenKantenListe();
  forall_adj_edges (hilfsKante,ka[1]) {
    switch( (netzplangraph->inf (hilfsKante))->holenID()) {
    case 1 :  (*kantenListe)[hilfsKante] = 64;
      break;
    case 2 : (*kantenListe)[hilfsKante] = 239;
      break;
    }
  }
	
  kantenListe = (netzplangraph->inf(ka[2]))->holenKantenListe();
  forall_adj_edges (hilfsKante,ka[2]) {
    switch( (netzplangraph->inf (hilfsKante))->holenID()) {
    case 2 :  (*kantenListe)[hilfsKante] = 49;
      break;
    case 3 : (*kantenListe)[hilfsKante] = 105;
      break;
    case 4 : (*kantenListe)[hilfsKante] = 136;
      break;
    }
  }
	
  kantenListe = (netzplangraph->inf(ka[3]))->holenKantenListe();
  forall_adj_edges (hilfsKante,ka[3]) {
    switch( (netzplangraph->inf (hilfsKante))->holenID()) {
    case 3 :  (*kantenListe)[hilfsKante] = 67;
      break;
    case 5 : (*kantenListe)[hilfsKante] = 57;
      break;
    case 6 : (*kantenListe)[hilfsKante] = 29;
      break;
    case 7 : (*kantenListe)[hilfsKante] = 103;
      break;
    }
  }
	
  kantenListe = (netzplangraph->inf(ka[4]))->holenKantenListe();
  forall_adj_edges (hilfsKante,ka[4]) {
    switch( (netzplangraph->inf (hilfsKante))->holenID()) {
    case 4 :  (*kantenListe)[hilfsKante] = 97;
      break;
    case 7 : (*kantenListe)[hilfsKante] = 74;
      break;
    case 8 : (*kantenListe)[hilfsKante] = 54;
      break;
    case 9 : (*kantenListe)[hilfsKante] = 47;
      break;
    }
  }
	
  kantenListe = (netzplangraph->inf(ka[5]))->holenKantenListe();
  forall_adj_edges (hilfsKante,ka[5]) {
    switch( (netzplangraph->inf (hilfsKante))->holenID()) {
    case 8 :  (*kantenListe)[hilfsKante] = 359;
    }
  }	
	
  kantenListe = (netzplangraph->inf(ka[6]))->holenKantenListe();
  forall_adj_edges (hilfsKante,ka[6]) {
    switch( (netzplangraph->inf (hilfsKante))->holenID()) {
    case 9 :  (*kantenListe)[hilfsKante] = 359;
      break;
    }
  }	
	
  kantenListe = (netzplangraph->inf(ka[7]))->holenKantenListe();
  forall_adj_edges (hilfsKante,ka[7]) {
    switch( (netzplangraph->inf (hilfsKante))->holenID()) {
    case 6 :  (*kantenListe)[hilfsKante] = 311;
      break;
    }
  }

  kantenListe = (netzplangraph->inf(ka[8]))->holenKantenListe();
  forall_adj_edges (hilfsKante,ka[8]) {
    switch( (netzplangraph->inf (hilfsKante))->holenID()) {
    case 5 :  (*kantenListe)[hilfsKante] = 303;
      break;
    }
  }	
 	
  cout << "jetzt kommen die Linien";
  list<int>* halteListe;

  CLinie* NLinie;



  
  NLinie = new CLinie();
  NLinie->setzenID(1);
  halteListe = NLinie->holenhListe();
  halteListe->append (3);
  halteListe->append (2);
  halteListe->append (1);
  vorgegebeneLinien->append (NLinie);

  NLinie = new CLinie();
  NLinie->setzenID(2);
  halteListe = NLinie->holenhListe();
  halteListe->append (2);
  halteListe->append (3);
  halteListe->append (4);
  halteListe->append (5);
  halteListe->append (6);
  vorgegebeneLinien->append (NLinie);
  /*
    NLinie = new CLinie();
    NLinie->setzenID(3);
    halteListe = NLinie->holenhListe();
    halteListe->append (2);
    halteListe->append (3);
    halteListe->append (5);
    vorgegebeneLinien->append (NLinie);
    
    NLinie = new CLinie();
    NLinie->setzenID(4);
    halteListe = NLinie->holenhListe();
    halteListe->append (6);
    halteListe->append (5);
    halteListe->append (4);
    vorgegebeneLinien->append (NLinie);

    NLinie = new CLinie();
    NLinie->setzenID(5);
    halteListe = NLinie->holenhListe();
    halteListe->append (2);
    halteListe->append (3);
    halteListe->append (4);
    halteListe->append (9);

    vorgegebeneLinien->append (NLinie);
  */
  NLinie = new CLinie();
  NLinie->setzenID(3);
  halteListe = NLinie->holenhListe();
  halteListe->append (4);
  halteListe->append (5);
  halteListe->append (7);
  vorgegebeneLinien->append (NLinie);
  /*
    NLinie = new CLinie();
    NLinie->setzenID(7);
    halteListe = NLinie->holenhListe();
    halteListe->append (5);
    halteListe->append (4);
    halteListe->append (3);
    halteListe->append (2);
    vorgegebeneLinien->append (NLinie);
                            	
    NLinie = new CLinie();
    NLinie->setzenID(8);
    halteListe = NLinie->holenhListe();
    halteListe->append (3);
    halteListe->append (5);
    halteListe->append (7);
    vorgegebeneLinien->append (NLinie);

    NLinie = new CLinie();
    NLinie->setzenID(9);
    halteListe = NLinie->holenhListe();
    halteListe->append (3);
    halteListe->append (5);
    halteListe->append (6);
    vorgegebeneLinien->append (NLinie);

    NLinie = new CLinie();
    NLinie->setzenID(10);
    halteListe = NLinie->holenhListe();
    halteListe->append (4);
    halteListe->append (5);
    halteListe->append (7);
    vorgegebeneLinien->append (NLinie);

    NLinie = new CLinie();
    NLinie->setzenID(11);
    halteListe = NLinie->holenhListe();
    halteListe->append (8);
    halteListe->append (4);
    halteListe->append (5);
    vorgegebeneLinien->append (NLinie);

    NLinie = new CLinie();
    NLinie->setzenID(12);
    halteListe = NLinie->holenhListe();
    halteListe->append (8);
    halteListe->append (4);
    halteListe->append (9);
    vorgegebeneLinien->append (NLinie);

    NLinie = new CLinie();
    NLinie->setzenID(13);
    halteListe = NLinie->holenhListe();
    halteListe->append (7);
    halteListe->append (5);
    halteListe->append (6);
    vorgegebeneLinien->append (NLinie);
  */
  Debug (2,"LP-Testdaten erzeugt");
}




void rezatest(){
  // Erstmal was ausgeben
  cout << "Testprogramm fuer die Klassen im Paket Linienplan\n\n";
  Debug(4,"test");
  cout << "Zuerst brauchen wir die Schnittstelle zum Programm\n";
  cout << "CLPSchnittstelle lpschnittstelle\n";
  //	CLPSchnittstelle lpschnittstelle;
  // so muss es eigentlich laufen und zwar ueber die schnittstelle

  matrix *bedarf;
  list<CLinie*> *linienListe;
  CLinie* linie;
  list<int>* obereHListe;

  UGRAPH<CNetzplanKnoten*,CNetzplanKante*> *graph;
  cout << "go\n";
  holenDaten (bedarf,linienListe,graph);
  CNetzplan Netzplan = CNetzplan(true);
  Netzplan.setzenNetzplan(graph);
  Netzplan.setzenLinienliste(linienListe);
  Netzplan.setzenMaxLinienlaenge (400000);
  forall (linie, *linienListe){
    cout << "Linie " << linie->holenID() << " = ";
    int zahl;
    obereHListe = linie->holenhListe();
    forall (zahl, *obereHListe) {
      cout << " " << zahl;
    } ;
    cout << "\n";
  };

  CAbschlussverknuepfung Abschlussverknuepfung = CAbschlussverknuepfung(&Netzplan,bedarf);
  Abschlussverknuepfung.durchfuehrenAufbruchsverknuepfung();
  cout << "ready\n";       	


  cout << "ende\n";
}

